include VMStat.inc

;**********************CODE SEGMENT*********************************
.code 
start:;START PROG HERE. 
		invoke	GetModuleHandle,NULL
		mov	hInstance,eax
		invoke	InitCommonControls
		invoke	DialogBoxParam,hInstance,IDD_VMSTAT,NULL,offset DlgProc,0
		invoke	ExitProcess,NULL

;***********DIALOG MESSAGE PROCEDURE*****************************
DlgProc	proc hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
local ms:MEMORYSTATUS
		mov	eax,uMsg
		.if	eax == WM_CLOSE
			invoke	EndDialog,hWnd,NULL
		.elseif	eax == WM_INITDIALOG
			invoke LoadIcon,hInstance,IDI_VMSTAT
			push eax
			invoke SendMessage,hWnd,WM_SETICON,ICON_SMALL,eax		
			pop eax
			invoke SendMessage,hWnd,WM_SETICON,ICON_BIG,eax
			
			invoke SetTimer,hWnd, IDT_UPDATE,1000, NULL
			
			;Force a timer message for the initial update.
			invoke SendMessage,hWnd,WM_TIMER,IDT_UPDATE,NULL
			
		.elseif eax == WM_TIMER
			;Initialize the structure length before calling 
			;GlobalMemoryStatus.
			invoke GlobalMemoryStatus,addr ms
			invoke wsprintf,addr szTemp,SADD("%d"),ms.dwMemoryLoad
			invoke lstrcat,addr szData,addr szTemp
			invoke lstrcat,addr szData,addr Changeline
			invoke wsprintf,addr szTemp,SADD("%d"),ms.dwTotalPhys
			invoke lstrcat,addr szData,addr szTemp
			invoke lstrcat,addr szData,addr Changeline
			invoke wsprintf,addr szTemp,SADD("%d"),ms.dwAvailPhys
			invoke lstrcat,addr szData,addr szTemp
			invoke lstrcat,addr szData,addr Changeline
			invoke wsprintf,addr szTemp,SADD("%d"),ms.dwTotalPageFile
			invoke lstrcat,addr szData,addr szTemp
			invoke lstrcat,addr szData,addr Changeline
			invoke wsprintf,addr szTemp,SADD("%d"),ms.dwAvailPageFile
			invoke lstrcat,addr szData,addr szTemp
			invoke lstrcat,addr szData,addr Changeline
			invoke wsprintf,addr szTemp,SADD("%d"),ms.dwTotalVirtual
			invoke lstrcat,addr szData,addr szTemp
			invoke lstrcat,addr szData,addr Changeline
			invoke wsprintf,addr szTemp,SADD("%d"),ms.dwAvailVirtual	
			invoke lstrcat,addr szData,addr szTemp
			invoke lstrcat,addr szData,addr Changeline

			INVOKE SetDlgItemText,hWnd, IDC_DATA,addr szData
		
		.elseif	eax == WM_COMMAND
			mov	eax,wParam
			and eax,0ffffh
			.if	eax  == IDCANCEL
				invoke KillTimer,hWnd, IDT_UPDATE
				invoke	EndDialog,hWnd,NULL
			.endif
		.else
			mov	eax,FALSE
			ret
		.endif		   
		mov	eax,TRUE
		ret
		
DlgProc	endp
;********************************************************************

end	start
